<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method='text' indent="no"/>

<xsl:key name="distinctEvents" match="//conditionNode[@type='EVENT']" use="parameter[@name='name']/@value"/>
<xsl:key name="distinctInputVariables" match="//conditionNode[@type='INPUT_VARIABLE']" use="parameter[@name='name']/@value"/>
<xsl:key name="distinctOutputActions" match="//actionNode[@type='OUTPUT_ACTION']" use="parameter[@name='name']/@value"/>

<xsl:template match="/model">
//--- this file is machine generated ---

#include "StdAfx.h"
#include "log_user.h"

#ifdef SWITCH_LOGGING

typedef struct{
  ubyte       dig;
  const char* n;
  const char* n_name;
} int_str2_t;

typedef struct{
  const char* n;
  const char* n_name;
} str2_t;

typedef struct{
  const char* n;
  const char* n_name;
  str2_t* str2;
} str3_t;

<xsl:variable name="events" select="//conditionNode[generate-id(.) = generate-id(key('distinctEvents', parameter[@name='name']/@value))]" />
int_str2_t e_str2[<xsl:value-of select="count($events) + 1"/>] = 
{
  {  0, "e0", "_initializing_" }
 <xsl:choose>
 <xsl:when test="count($events) > 0">,
  <xsl:for-each select="//conditionNode[generate-id(.) = generate-id(key('distinctEvents', @name))][@type='EVENT']">
	<xsl:sort select="@name"/>
  {  <xsl:value-of select="@name"/>, "e<xsl:value-of select="@name"/>", "<xsl:value-of select="ancestor::stateMachine/nodeDescriptions/node[@name=current()/@name][@type=current()/@type]/@description"/>" }
	<xsl:if test="not(position()=last())">,</xsl:if>
  </xsl:for-each>
 </xsl:when>
 <xsl:otherwise>
 </xsl:otherwise>
 </xsl:choose>
};

<xsl:variable name="inputVariables" select="//conditionNode[generate-id(.) = generate-id(key('distinctInputVariables', parameter[@name='name']/@value))]" />
<xsl:choose>
<xsl:when test="count($inputVariables) > 0">
str2_t x_str2[<xsl:value-of select="count($inputVariables)"/>] = 
{
  <xsl:for-each select="$inputVariables">
    <xsl:sort select="@name"/>
    { "x<xsl:value-of select="@name"/>", "<xsl:value-of select="ancestor::stateMachine/nodeDescriptions/node[@name=current()/@name][@type=current()/@type]/@description"/>" }
    <xsl:if test="not(position()=last())">,</xsl:if>
  </xsl:for-each>
};
</xsl:when>
<xsl:otherwise>
str2_t* x_str2 = NULL;
</xsl:otherwise>
</xsl:choose>

<xsl:variable name="outputVariables" select="//actionNode[generate-id(.) = generate-id(key('distinctOutputActions', parameter[@name='name']/@value))]" />
<xsl:choose>
<xsl:when test="count($outputVariables) > 0">
str2_t z_str2[<xsl:value-of select="count($outputVariables)"/>] = 
{
  <xsl:for-each select="$outputVariables">
    <xsl:sort select="@name"/>
    { "z<xsl:value-of select="@name"/>", "<xsl:value-of select="ancestor::stateMachine/nodeDescriptions/node[@name=current()/@name][@type=current()/@type]/@description"/>" }
    <xsl:if test="not(position()=last())">,</xsl:if>
  </xsl:for-each>
};
</xsl:when>
<xsl:otherwise>
str2_t* z_str2 = NULL;
</xsl:otherwise>
</xsl:choose>

<xsl:for-each select="stateMachine">
str2_t a<xsl:value-of select="@name"/>_str2[<xsl:value-of select="//state[count(state)=0]" />] = 
{
  <xsl:for-each select="//state[count(state)=0]">
    { "<xsl:value-of select="@name"/>", "<xsl:value-of select="@description"/>" }
    <xsl:if test="not(position()=last())">,</xsl:if>
  </xsl:for-each>
};
</xsl:for-each>


str3_t A_str3[<xsl:value-of select="count(stateMachine)"/>] = 
{
<xsl:for-each select="stateMachine">
  { "A<xsl:value-of select="@name"/>", "<xsl:value-of select="description"/>", a<xsl:value-of select="@name"/>_str2 }
  <xsl:if test="not(position()=last())">,</xsl:if>
</xsl:for-each>
};


//---------------------------------------------------------------------------
void e_find(ubyte e, const char** n, const char** n_name)
{
  static const char* nothing = "No description found!";
  *n = nothing;
  *n_name = nothing;
  for(uint i = 0; i &lt; 2; i++)
    if(e_str2[i].dig == e){
      *n = e_str2[i].n; *n_name = e_str2[i].n_name; return;
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void log_a_begin_user(const char* a, const char* a_name, const char* y, const char* y_name, const char* e, const char* e_name);
void log_a_begin(ubyte a, ubyte y, ubyte e)
{
  const char *e_n, *e_n_name;
  e_find(e, &amp;e_n, &amp;e_n_name);
  log_a_begin_user(A_str3[a].n, A_str3[a].n_name, A_str3[a].str2[y].n, A_str3[a].str2[y].n_name, e_n, e_n_name);
}
//---------------------------------------------------------------------------
void log_a_trans_user(const char* a, const char* a_name, const char* yo, const char* yo_name, const char* yn, const char* yn_name);
void log_a_trans(ubyte a, ubyte yo, ubyte yn)
{
  log_a_trans_user(A_str3[a].n, A_str3[a].n_name, A_str3[a].str2[yo].n, A_str3[a].str2[yo].n_name, A_str3[a].str2[yn].n, A_str3[a].str2[yn].n_name);
}
//---------------------------------------------------------------------------
void log_a_end_user(const char* a, const char* a_name, const char* y, const char* y_name, const char* e, const char* e_name);
void log_a_end(ubyte a, ubyte y, ubyte e)
{
  const char *e_n, *e_n_name;
  e_find(e, &amp;e_n, &amp;e_n_name);
  log_a_end_user(A_str3[a].n, A_str3[a].n_name, A_str3[a].str2[y].n, A_str3[a].str2[y].n_name, e_n, e_n_name);
}
//---------------------------------------------------------------------------
void log_x_user(const char* x, const char* x_name, ubyte res);
void log_x(ubyte x, ubyte res)
{
  log_x_user(x_str2[x].n, x_str2[x].n_name, res);
}
//---------------------------------------------------------------------------
void log_z_user(const char* z, const char* z_name);
void log_z(ubyte z)
{
  log_z_user(z_str2[z].n, z_str2[z].n_name);
}
//---------------------------------------------------------------------------
void log_write_user(char ch, const char* str);
void log_write(char ch, const char* str)
{
  log_write_user(ch, str);
}
//---------------------------------------------------------------------------

#endif
</xsl:template>

</xsl:stylesheet>