<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method='text' indent="no"/>


<xsl:template match="/model">
//--- this file is machine generated ---

#ifndef LogH
#define LogH

#include "types.h"

#define SWITCH_LOGGING

#ifdef SWITCH_LOGGING
  #define Z_LOGGING
  #define X_LOGGING
  #define A_BEGINS_LOGGING
  #define A_TRANS_LOGGING
  #define A_ENDS_LOGGING
  #define A_ERRORS_LOGGING

  enum{
    LOG_Z = '*',
    LOG_X = '>',
    LOG_GRAPH_BEGIN = '{',
    LOG_GRAPH_TRANS = 'T',
    LOG_GRAPH_END = '}',
    LOG_GRAPH_ERROR = 'E'
  };

  void log_a_begin(ubyte a, ubyte y, ubyte e);
  void log_a_trans(ubyte a, ubyte yo, ubyte yn);
  void log_a_end(ubyte a, ubyte y, ubyte e);
  void log_x(ubyte x, ubyte res);
  void log_z(ubyte z);
  void log_write(char, const char* str);
#endif

#ifdef A_BEGINS_LOGGING
  <xsl:for-each select="stateMachine">
	#define A<xsl:value-of select="@name"/>_BEGIN_LOGGING
  </xsl:for-each>
  
  <xsl:variable name="relatedAutomatas" select="//*[ ((name()='actionNode') and ((@type='AUTOMATA_CALL') or (@type='SIMPLE_AUTOMATA_CALL_IN_STATE'))) or
													 ((name()='conditionNode') and ((@type='OTHER_AUTOMATA_EVENT_NOTEQUAL') or (@type='OTHER_AUTOMATA_EVENT_EQUAL')))]
		[not(parameter[@name='automata']/@value=ancestor::model/stateMachine/@name)]
		[not(parameter[@name='automata']/@value=preceding::*[ ((name()='actionNode') and ((@type='AUTOMATA_CALL') or (@type='SIMPLE_AUTOMATA_CALL_IN_STATE'))) or
															 ((name()='conditionNode') and ((@type='OTHER_AUTOMATA_EVENT_NOTEQUAL') or (@type='OTHER_AUTOMATA_EVENT_EQUAL')))]/parameter[@name='automata']/@value)]" />
  <xsl:for-each select="$relatedAutomatas" >
	<xsl:sort select="parameter[@name='automata']/@value"/>
	#define A<xsl:value-of select="parameter[@name='automata']/@value"/>_BEGIN_LOGGING
  </xsl:for-each>
  
#endif

#ifdef A_TRANS_LOGGING
  <xsl:for-each select="stateMachine">
	#define A<xsl:value-of select="@name"/>_TRANS_LOGGING
  </xsl:for-each>
  
  <xsl:for-each select="$relatedAutomatas" >
	<xsl:sort select="parameter[@name='automata']/@value"/>
	#define A<xsl:value-of select="parameter[@name='automata']/@value"/>_TRANS_LOGGING
  </xsl:for-each>
 
#endif

#ifdef A_ENDS_LOGGING
  <xsl:for-each select="stateMachine">
	#define A<xsl:value-of select="@name"/>_END_LOGGING
  </xsl:for-each>
  
  <xsl:for-each select="$relatedAutomatas" >
	<xsl:sort select="parameter[@name='automata']/@value"/>
	#define A<xsl:value-of select="parameter[@name='automata']/@value"/>_END_LOGGING
  </xsl:for-each>
  
#endif

#ifdef A_ERRORS_LOGGING
  <xsl:for-each select="stateMachine">
	#define A<xsl:value-of select="@name"/>_ERRORS_LOGGING
  </xsl:for-each>
  
  
  <xsl:for-each select="$relatedAutomatas" >
	<xsl:sort select="parameter[@name='automata']/@value"/>
	#define A<xsl:value-of select="parameter[@name='automata']/@value"/>_ERRORS_LOGGING
  </xsl:for-each>
#endif

#endif
</xsl:template>

</xsl:stylesheet>