<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method='text' indent="no"/>

<xsl:key name="distinctInputVariables" match="//conditionNode[@type='INPUT_VARIABLE']" use="parameter[@name='name']/@value"/>

<xsl:template match="/model">
//--- this file is machine generated ---

#include "StdAfx.h"
#include "common.h"
#include "log.h"

<xsl:for-each select="//conditionNode[generate-id(.) = generate-id(key('distinctInputVariables', parameter[@name='name']/@value))]">
    <xsl:sort select="@type"/>
    <xsl:sort select="@name"/>

    //---------------------------------------------------------------------------
    ubyte x<xsl:value-of select="@name"/>_user(void);
    ubyte x<xsl:value-of select="@name"/>(void)
    {
      ubyte b = x<xsl:value-of select="@name"/>_user();
    
      #ifdef X_LOGGING
        log_x(<xsl:value-of select="position()-1" />, b);
      #endif

      return b;
    }
</xsl:for-each>

</xsl:template>

</xsl:stylesheet>